100 ' Zahnradgenerator fr AutoCAD
110 ' Erzeugt anhand der eingegebenen Werte ein DXF-File,
120 ' das mit "DXFIN" in die CAD-Zeichnung hinzugefgt werden kann
130 ' S e h r   w i c h t i g : Da AutoCAD intern mit 14 signifikanten
140 '                           Stellen arbeitet, wird zur Fileerzeugung die
150 '                           doppeltgenaue Gleitkommaarithmetik eingesetzt.
160 '                           Da zur Zahnradberechnung Trigonometrie bentigt
170 '                           wird, muss der BASIC-Interpreter mit "/D" gela-
180 '                           den werden!
190 :
200 ' Test, ob der BASIC-Interpreter mit "/D" geladen wurde
210 :
220 IF LEN(STR$(SIN(1#)))>10 THEN 260
230 PRINT "Beim Laden des BASIC-Interpreters wurde ";CHR$(34);"/D";CHR$(34);" vergessen."
240 PRINT "Bitte den BASIC-Interpreter mit angehngten ";CHR$(34);"/D";CHR$(34);" neustarten!"
250 SYSTEM
260 CLS
270 PRINT "   *** CAD-Zahnrad fr AutoCAD ***"
280 PRINT "Erzeugt anhand der eingegebenen Werte ein DXF-File,"
290 PRINT "das mit ";CHR$(34);"DXFIN";CHR$(34);"in die CAD-Zeichnung hinzugefgt werden kann."
300 PRINT "Elementart: geschlossene Polylinie"
310 PRINT
320 INPUT "Mittelpunkt ";X#,Y#
325 INPUT "Stellung des 1. Zahnes (Winkel in ) ";AL#
330 INPUT "Modul ";M#
340 IF M#<=0# THEN PRINT "Ungltig!":GOTO 330
350 INPUT "Zhnezahl ";Z%
360 IF Z%<1 THEN PRINT "Ungltig!":GOTO 350
370 INPUT "Kopfhhenfaktor (nach Norm 1) ";HAF#
380 INPUT "Fusshhenfaktor (nach Norm 1.25) ";HFF#
390 INPUT "Eingriffswinkel in  (nach Norm 20) ";BET#
400 INPUT "Zeichengenauigkeit der Zahnflanken-Evolvente (Anzahl Linien) ";GEN1%
410 IF GEN1%<1 THEN PRINT "Ungltig!":GOTO 400
420 INPUT "Layername in der entsprechenden CAD-Zeichnung (z.B. 07930000) ";LA$
430 INPUT "Dateiname (inkl. Laufwerk und Pfad, jedoch ohne Suffix!) ";DN$
440 :
450 OPEN DN$+".DXF" FOR OUTPUT AS 1%
460 PRINT#1,0:PRINT#1,"SECTION"
470 PRINT#1,2:PRINT#1,"ENTITIES"
480 GOSUB 10000
600 PRINT#1,0:PRINT#1,"ENDSEC"
610 PRINT#1,0:PRINT#1,"EOF"
620 :
630 END
640 :
10000 ' Unterprogramm ZeichneZahnrad
10010 :
10020 ' Eingangsparameter (Variablen):
10030 ' x#,y#  : Mittelpunkt des Zahnrades auf dem Bildschirm
10040 ' m#     : Modul des Zahnrades (in Bildpunkten!)
10050 ' z%     : Zhnezahl des Zahnrades
10060 ' hff#   : Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
10070 ' haf#   : Kopfhhenfaktor (bei genormten Rder normalerweise 1)
10080 ' Bet#   : Eingriffswinkel in  (bei genormten Rder normalerweise 20)
10090 ' Al#    : Lagewinkel des ersten Zahnes in 
10100 ' Gen1%  : Zeichengenauigkeit der Evolvente (Anzahl Linien)
10110 ' La$    : Layer in der AutoCAD-Zeichnung (z.B. 07930000)
10120 :
10130 PRINT#1,0
10140 PRINT#1,"POLYLINE"
10143 PRINT#1,8
10146 PRINT#1,LA$
10150 PRINT#1,66
10160 PRINT#1,"    1"
10170 PRINT#1,70
10180 PRINT#1,"    1"
10190 IF HFF#>CDBL(Z%)/2# THEN HFF#=CDBL(Z%)/2#
10200 D#=M#*CDBL(Z%)
10210 PI#=4#*ATN(1#)
10220 DF#=D#-2#*M#*HFF#
10230 DA#=D#+2#*M#*HAF#
10240 ALR#=AL#/180#*PI#
10250 BETR#=BET#/180#*PI#
10260 DG#=D#*COS(BETR#)
10270 IF DF#<DG# THEN E%=-1:SWFR#=0# ELSE E%=0:SWFR#=SQR(DF#*DF#-DG#*DG#)/DG#
10280 SWAR#=SQR(DA#*DA#-DG#*DG#)/DG#
10290 TEILW#=2#*PI#/CDBL(Z%)
10300 DELR#=TAN(BETR#)
10310 WW#=TEILW#/4#-BETR#+DELR#
10320 WFR#=WW#-SWFR#+ATN(SWFR#)
10330 WAR#=WW#-SWAR#+ATN(SWAR#)
10340 ABA#=TAN(WAR#/2#)
10350 ABF#=TAN(TEILW#/4#-WFR#/2#)
10360 F%=WFR#<TEILW#/2#
10370 A%=WAR#>0#
10380 IF A% THEN 10440
10390 SWAR#=1024#:H#=512#
10400 FOR I%=0 TO 80
10410 IF SWAR#-WW#>ATN(SWAR#) THEN SWAR#=SWAR#-H# ELSE SWAR#=SWAR#+H#
10420 H#=H#/2#
10430 NEXT I%
10440 IF F% THEN 10500
10450 SWFR#=1024#:H#=512#
10460 FOR I%=0 TO 80
10470 IF SWFR#-WW#+TEILW#/2#>ATN(SWFR#) THEN SWFR#=SWFR#-H# ELSE SWFR#=SWFR#+H#
10480 H#=H#/2#
10490 NEXT I%
10500 R#=DG#/2#
10510 SW#=(SWAR#-SWFR#)/CDBL(GEN1%)
10520 S#=ALR#+WAR#
10580 FOR ZAHN%=0 TO Z%-1
10590 LWR#=ALR#+TEILW#*CDBL(ZAHN%)
10600 SWR#=-SWAR#
10610 W#=LWR#+WW#
10620 GOSUB 10870
10630 IF NOT F% THEN 10770
10640 E1#=LWR#+TEILW#-WFR#
10650 IF NOT E% THEN 10710
10660 S1#=LWR#+WFR#
10670 PRINT#1,0:PRINT#1,"VERTEX"
10680 PRINT#1,8:PRINT#1,LA$
10690 PRINT#1,10:H$=STR$(X#+DF#/2#*COS(S1#)):B%=INSTR(H$,"D")
10695 IF B% THEN MID$(H$,B%)="E"
10697 PRINT#1,H$
10700 PRINT#1,20:H$=STR$(Y#+DF#/2#*SIN(S1#)):B%=INSTR(H$,"D")
10705 IF B% THEN MID$(H$,B%)="E"
10707 PRINT#1,H$
10710 AB#=ABF#:R1#=DF#/2#:GOSUB 10960
10720 IF NOT E% THEN 10770
10730 PRINT#1,0:PRINT#1,"VERTEX"
10740 PRINT#1,8:PRINT#1,LA$
10750 PRINT#1,10:H$=STR$(X#+R#*COS(E1#)):B%=INSTR(H$,"D")
10755 IF B% THEN MID$(H$,B%)="E"
10757 PRINT#1,H$
10760 PRINT#1,20:H$=STR$(Y#+R#*SIN(E1#)):B%=INSTR(H$,"D")
10765 IF B% THEN MID$(H$,B%)="E"
10767 PRINT#1,H$
10770 SWR#=SWFR#
10780 W#=LWR#-WW#+TEILW#
10790 GOSUB 10870
10800 E1#=LWR#+TEILW#+WAR#
10810 AB#=ABA#:R1#=DA#/2#:IF A% THEN GOSUB 10960
10820 NEXT ZAHN%
10830 PRINT#1,0:PRINT#1,"SEQEND"
10840 PRINT#1,8:PRINT#1,LA$
10850 RETURN
10860 :
10870 FOR I%=1 TO GEN1%
10880 A#=W#+SWR#+CDBL(I%)*SW#:B#=(A#-W#)*R#
10890 PRINT#1,0:PRINT#1,"VERTEX"
10900 PRINT#1,8:PRINT#1,LA$
10910 PRINT#1,10:H$=STR$(X#+R#*COS(A#)+B#*SIN(A#)):B%=INSTR(H$,"D")
10915 IF B% THEN MID$(H$,B%)="E"
10917 PRINT#1,H$
10920 PRINT#1,20:H$=STR$(Y#+R#*SIN(A#)-B#*COS(A#)):B%=INSTR(H$,"D")
10925 IF B% THEN MID$(H$,B%)="E"
10927 PRINT#1,H$
10930 NEXT I%
10940 RETURN
10950 :
10960 PRINT#1,42:H$=STR$(AB#):B%=INSTR(H$,"D")
10962 IF B% THEN MID$(H$,B%)="E"
10964 PRINT#1,H$
10966 PRINT#1,0:PRINT#1,"VERTEX"
10970 PRINT#1,8:PRINT#1,LA$
10980 PRINT#1,10:H$=STR$(X#+R1#*COS(E1#)):B%=INSTR(H$,"D")
10985 IF B% THEN MID$(H$,B%)="E"
10987 PRINT#1,H$
10990 PRINT#1,20:H$=STR$(Y#+R1#*SIN(E1#)):B%=INSTR(H$,"D")
10995 IF B% THEN MID$(H$,B%)="E"
10997 PRINT#1,H$
11010 RETURN
11020 :
20000 ' Unterprogramm BerechneNeulage
20010 :
20020 ' Eingangsparameter (Variablen):
20030 ' x#,y#,m#,z%,Al# : Alte Werte; diese werden entsprechend verndert
20040 ' nz%             : Neue Zhnezahl
20050 ' w#              : Lgewinkel des eingreifenden Rades relativ zum alten
20060 '                   Rades
20070 :
20080 A#=CDBL(Z%+NZ%)*M#/2#
20090 UM#=ATN(1#)/45#
20100 X#=X#+A#*COS(W#*UM#)
20110 Y#=Y#+A#*SIN(W#*UM#)
20120 AL#=W#-180#+180#/CDBL(NZ%)+(W#-AL#)*CDBL(Z%)/CDBL(NZ%)
20130 Z%=NZ%
20140 RETURN
